Attribute VB_Name = "modFunctions"
Option Explicit

Public Enum eSettings
    WinAmpPfad
    ReferenzVerzeichnis
    ZielVerzeichnis
End Enum

Public Function GetDrives()

Dim lngRetVal As Long
Dim strBuffer As String
Dim Drives() As String
Dim n As Long

strBuffer = Space(64)
lngRetVal = GetLogicalDriveStrings(64, strBuffer)
strBuffer = Left$(strBuffer, lngRetVal)

Drives = Split(strBuffer, Chr$(0))
GetDrives = Drives

End Function

Function GetNetRessources() As Collection

Const MAX_RESOURCES = 256
Const NOT_A_CONTAINER = -1
  
Dim bFirstTime As Boolean
Dim lRet As Long, hEnum As Long, lCnt As Long, lMin As Long, lLen As LoadPictureColorConstants, l As Long, lBufSize As Long, lLastIx As Long
Dim nRem$, F$
Dim ResList As Collection
Dim uNetApi(0 To MAX_RESOURCES) As NETRESOURCE
Dim uNet() As NETRESOURCE_REAL
  
Set ResList = New Collection
bFirstTime = True
    
Do
    If bFirstTime Then
        lRet = WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_ALL, ByVal 0&, hEnum)
        bFirstTime = False
    Else
        If uNet(lLastIx).dwUsage And RESOURCEUSAGE_CONTAINER Then
            lRet = WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_ALL, uNet(lLastIx), hEnum)
        Else
            lRet = NOT_A_CONTAINER
            hEnum = 0
        End If
        lLastIx = lLastIx + 1
    End If
      
    If lRet = NO_ERROR Then
        lCnt = RESOURCE_ENUM_ALL
        Do
            lBufSize = UBound(uNetApi) * Len(uNetApi(0)) / 2
            lRet = WNetEnumResource(hEnum, lCnt, uNetApi(0), lBufSize)
            If lCnt > 0 Then
            ReDim Preserve uNet(0 To lMin + lCnt - 1) As NETRESOURCE_REAL
            
            For l = 0 To lCnt - 1
                uNet(lMin + l).dwScope = uNetApi(l).dwScope
                uNet(lMin + l).dwType = uNetApi(l).dwType
                uNet(lMin + l).dwDisplayType = uNetApi(l).dwDisplayType
                uNet(lMin + l).dwUsage = uNetApi(l).dwUsage
                
                If uNetApi(l).pLocalName Then
                    lLen = lstrlen(uNetApi(l).pLocalName)
                    uNet(lMin + l).sLocalName = Space$(lLen)
                    CopyMem ByVal uNet(lMin + l).sLocalName, ByVal uNetApi(l).pLocalName, lLen
                End If
                
                If uNetApi(l).pRemoteName Then
                    lLen = lstrlen(uNetApi(l).pRemoteName)
                    uNet(lMin + l).sRemoteName = Space$(lLen)
                    CopyMem ByVal uNet(lMin + l).sRemoteName, ByVal uNetApi(l).pRemoteName, lLen
                End If
                        
                If uNetApi(l).pComment Then
                    lLen = lstrlen(uNetApi(l).pComment)
                    uNet(lMin + l).sComment = Space$(lLen)
                    CopyMem ByVal uNet(lMin + l).sComment, ByVal uNetApi(l).pComment, lLen
                End If
                
                If uNetApi(l).pProvider Then
                    lLen = lstrlen(uNetApi(l).pProvider)
                    uNet(lMin + l).sProvider = Space$(lLen)
                CopyMem ByVal uNet(lMin + l).sProvider, ByVal uNetApi(l).pProvider, lLen
                End If
            Next l
        End If
            
        lMin = lMin + lCnt
        Loop While lRet = ERROR_MORE_DATA
    End If

    If hEnum Then l = WNetCloseEnum(hEnum)
Loop While lLastIx < lMin

If UBound(uNet) > 0 Then
    For l = 0 To UBound(uNet)
        If uNet(l).dwDisplayType = RESDTYPE_SHARE Then
            F = uNet(l).sRemoteName & uNet(l).sComment
            ResList.Add F & Space(35 - Len(F))
        End If
    Next l
End If
    
Set GetNetRessources = ResList
    
End Function

Public Function FileExists(ByVal strFileName As String) As Boolean

Dim nTest As String

nTest = LCase$(strFileName)
If Len(nTest) = 1 Then

    Select Case Left$(nTest, 1)
        Case "a" To "z"
        nTest = strFileName & ":\"
    End Select
    
ElseIf Len(nTest) = 2 Then
    Select Case Left$(nTest, 2)
            Case "a:" To "z:"
            nTest = strFileName & "\"
    End Select
End If

On Error Resume Next
FileExists = CBool(GetAttr(nTest) Or vbNormal Or vbHidden Or vbSystem Or vbArchive Or vbDirectory)

End Function

Public Sub ListBoxAppearance(ListBox As ListBox, Border As Boolean)

Dim nStyle As Long
Dim nBorder As Boolean
    
With ListBox
    Select Case Border
        Case False: .Appearance = 0
        Case True: .Appearance = 0
            nBorder = True
    End Select
    
    nStyle = GetWindowLong(.hWnd, GWL_STYLE)
    
    If nBorder Then
        nStyle = nStyle Or WS_BORDER
    Else
        nStyle = nStyle And Not WS_BORDER
    End If
    
    SetWindowLong .hWnd, GWL_STYLE, nStyle
    SetWindowPos .hWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_NOZORDER
    If Border Then .Appearance = 1
End With

End Sub

Public Function GetPCName() As String

Dim strName As String
strName = Space$(256)

GetComputerName strName, 255
strName = Trim$(strName)
strName = Left(strName, Len(strName) - 1)
GetPCName = strName

End Function

Public Function GetSetting(Setting As eSettings) As String

Dim strKey As String
Dim strSetting As String
Dim strTemp As String * 1000
Dim i As Long
Dim strReturn As String

Select Case Setting
    
    Case WinAmpPfad
    strKey = "Allgemein"
    strSetting = "WinAmpPfad"
    
    Case ReferenzVerzeichnis
    strKey = "Synchronizer"
    strSetting = "Referenzverzeichnis"
    
    Case ZielVerzeichnis
    strKey = "Synchronizer"
    strSetting = "Zielverzeichnis"
    
End Select

GetPrivateProfileString strKey, strSetting, "", strTemp, Len(strTemp), App.Path & "\optionen.ini"
            
For i = 1 To Len(strTemp)
    If Mid(strTemp, i, 1) <> Chr(0) Then
        strReturn = strReturn & Mid(strTemp, i, 1)
    End If
Next i

GetSetting = strReturn

End Function

Public Sub SaveSetting(Setting As eSettings, Value As String)

Dim strKey As String
Dim strSetting As String

Select Case Setting
    
    Case WinAmpPfad
    strKey = "Allgemein"
    strSetting = "WinAmpPfad"
    
    Case ReferenzVerzeichnis
    strKey = "Synchronizer"
    strSetting = "Referenzverzeichnis"
    
    Case ZielVerzeichnis
    strKey = "Synchronizer"
    strSetting = "Zielverzeichnis"
    
End Select

WritePrivateProfileString strKey, strSetting, Value, App.Path & "\optionen.ini"

End Sub

Public Sub SHDelete(vFiles As String, Optional lStartHwnd As Long)
 
Dim i As Long
Dim oFileOP As SHFILEOPSTRUCT
  
With oFileOP
    .hWnd = lStartHwnd
    If Right(vFiles, 1) = "\" Then vFiles = Left(vFiles, Len(vFiles) - 1)
    .pFrom = vFiles
    While Right$(.pFrom, 2) <> String$(2, vbNullChar)
        .pFrom = .pFrom & vbNullChar
    Wend

    .fFlags = FOF_SILENT
    .fFlags = .fFlags Or FOF_NOCONFIRMATION
    .wFunc = FO_DELETE
    
End With

SHFileOperation oFileOP

End Sub

Public Sub CopyFile(strVon, strNach, lngHwnd As Long)

Dim lResult As Long
Dim SHF As SHFILEOPSTRUCT

SHF.hWnd = lngHwnd
SHF.wFunc = FO_COPY
SHF.pFrom = strVon
SHF.pTo = strNach
SHF.fFlags = FOF_NOCONFIRMMKDIR Or FOF_NOCONFIRMATION
lResult = SHFileOperation(SHF)

If lResult Then
    MsgBox "Fehler beim kopieren", vbInformation, "Kopieren"
End If

End Sub
